#ifndef DIALOGFINDNREPLACE_H
#define DIALOGFINDNREPLACE_H

#include <QDialog>
#include <QTextDocument>
#include "ui_dialogReplace.h"

class DialogReplace : public QDialog, public Ui::DialogReplace {
    Q_OBJECT
public:
    DialogReplace(QWidget *parent = 0);
    ~DialogReplace();

    QString getFindExpr() const;
    QString getReplaceExpr() const;
    QTextDocument::FindFlags getFindOptions() const;

    void setFindExpr(const QString &expr) { findEntry->setText(expr); }

public slots:
    void onFindEntryChanged(const QString &findExpr);
    void onReplaceEntryChanged(const QString &replaceExpr);

    void show();

protected slots:
    void onClosing();
    void onClickedFindButton();
    void onClickedReplaceButton();
    void onClickedReplaceAllButton();

signals:
    void find(const QString expr, QTextDocument::FindFlags flags);
    void replace(const QString expr);
    void replaceAll(const QString expr);
    void closing();

protected:
    void changeEvent(QEvent *e);

    void init();
    void setSignals();

};

#endif // DIALOGFINDNREPLACE_H
