/*
 * Copyright 2010 Mihai Niculescu <q.quark@gmail.com>
 *
 * This file is part of EqualX Project (https://launchpad.net/equalx/)
 *
 * EqualX is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EqualX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PARSER_H
#define PARSER_H

#include <QMap>
#include <QString>

typedef QMap<QString,QString> TokenList;

class Parser
{
public:
    Parser();

    void addToken(const QString &tokenName, const QString &tokenValue=QString("") );
    void setTokenValue(const QString &tokenName, const QString &tokenValue=QString(""));
    const QString& getTokenValue(QString &tokenName) const;

    // parse this string according to tokens list
    QString parse(const QString &string);

protected:
    TokenList tokens;

};

#endif // PARSER_H
