#include "DialogReplace.h"
#include "ui_dialogReplace.h"

DialogReplace::DialogReplace(QWidget *parent) :
        QDialog(parent)
{
    setupUi(this);

    init();
}

DialogReplace::~DialogReplace()
{

}

void DialogReplace::init()
{
    setSignals();

}

void DialogReplace::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        retranslateUi(this);
        break;
    default:
        break;
    }
}

void DialogReplace::onClosing()
{
    emit closing();

    QDialog::close();
}

QString DialogReplace::getFindExpr() const
{
    return findEntry->text();
}

QString DialogReplace::getReplaceExpr() const
{
    return replaceEntry->text();
}

QTextDocument::FindFlags DialogReplace::getFindOptions() const
{
    QTextDocument::FindFlags opts;

    if( checkCase->isChecked() ) opts = QTextDocument::FindCaseSensitively;
    if( checkBackwards->isChecked() ) opts = opts | QTextDocument::FindBackward;
    if( checkWholeWords->isChecked() ) opts = opts | QTextDocument::FindWholeWords;

    return opts;
}

void DialogReplace::onFindEntryChanged(const QString &findExpr)
{
    bool findable = !findExpr.isEmpty();

    findButton->setEnabled( findable );
    replaceButton->setEnabled( findable );
    replaceAllButton->setEnabled( findable );
}

void DialogReplace::onReplaceEntryChanged(const QString &replaceExpr)
{

}

void DialogReplace::onClickedFindButton()
{
    QString expr = findEntry->text();
    QTextDocument::FindFlags searchFlags;

    if( checkCase->isChecked() ) searchFlags = searchFlags | QTextDocument::FindCaseSensitively;
    if( checkBackwards->isChecked() ) searchFlags = searchFlags | QTextDocument::FindBackward;
    if( checkWholeWords->isChecked() ) searchFlags = searchFlags | QTextDocument::FindWholeWords;

    emit find(expr, searchFlags);
}

void DialogReplace::onClickedReplaceButton()
{
     QString expr = replaceEntry->text();

    emit replace(expr);
}

void DialogReplace::onClickedReplaceAllButton()
{
    QString expr = replaceEntry->text();

    emit replaceAll(expr);
}

void DialogReplace::setSignals()
{
    connect(findEntry, SIGNAL(textChanged(QString)), this, SLOT(onFindEntryChanged(QString)) );
    connect(replaceEntry, SIGNAL(textChanged(QString)), this, SLOT(onReplaceEntryChanged(QString)) );
    connect(findButton, SIGNAL(clicked()), this, SLOT(onClickedFindButton()) );
    connect(replaceButton, SIGNAL(clicked()), this, SLOT(onClickedReplaceButton()) );
    connect(replaceAllButton, SIGNAL(clicked()), this, SLOT(onClickedReplaceAllButton()) );
    connect(closeButton, SIGNAL(clicked()), this, SLOT(onClosing()) );

}

void DialogReplace::show()
{
    QDialog::show();

    findEntry->setFocus();

}

